- [HTTP request](https://docs.cloud.google.com/compute/docs/reference/rest/beta/globalVmExtensionPolicies/insert#body.HTTP_TEMPLATE)
- [Path parameters](https://docs.cloud.google.com/compute/docs/reference/rest/beta/globalVmExtensionPolicies/insert#body.PATH_PARAMETERS)
- [Query parameters](https://docs.cloud.google.com/compute/docs/reference/rest/beta/globalVmExtensionPolicies/insert#body.QUERY_PARAMETERS)
- [Request body](https://docs.cloud.google.com/compute/docs/reference/rest/beta/globalVmExtensionPolicies/insert#body.request_body)
  - [JSON representation](https://docs.cloud.google.com/compute/docs/reference/rest/beta/globalVmExtensionPolicies/insert#body.request_body.SCHEMA_REPRESENTATION)
    - [JSON representation](https://docs.cloud.google.com/compute/docs/reference/rest/beta/globalVmExtensionPolicies/insert#body.request_body.SCHEMA_REPRESENTATION.instance_selectors.SCHEMA_REPRESENTATION)
    - [JSON representation](https://docs.cloud.google.com/compute/docs/reference/rest/beta/globalVmExtensionPolicies/insert#body.request_body.SCHEMA_REPRESENTATION.rollout_operation.SCHEMA_REPRESENTATION)
    - [JSON representation](https://docs.cloud.google.com/compute/docs/reference/rest/beta/globalVmExtensionPolicies/insert#body.request_body.SCHEMA_REPRESENTATION.rollout_operation.SCHEMA_REPRESENTATION_1)
- [Response body](https://docs.cloud.google.com/compute/docs/reference/rest/beta/globalVmExtensionPolicies/insert#body.response_body)
  - [JSON representation](https://docs.cloud.google.com/compute/docs/reference/rest/beta/globalVmExtensionPolicies/insert#body.Operation.SCHEMA_REPRESENTATION)
    - [JSON representation](https://docs.cloud.google.com/compute/docs/reference/rest/beta/globalVmExtensionPolicies/insert#body.Operation.SCHEMA_REPRESENTATION.error.SCHEMA_REPRESENTATION)
      - [JSON representation](https://docs.cloud.google.com/compute/docs/reference/rest/beta/globalVmExtensionPolicies/insert#body.Operation.SCHEMA_REPRESENTATION.error.SCHEMA_REPRESENTATION.error_details.SCHEMA_REPRESENTATION)
      - [JSON representation](https://docs.cloud.google.com/compute/docs/reference/rest/beta/globalVmExtensionPolicies/insert#body.Operation.SCHEMA_REPRESENTATION.error.SCHEMA_REPRESENTATION.error_details.SCHEMA_REPRESENTATION_1)
      - [JSON representation](https://docs.cloud.google.com/compute/docs/reference/rest/beta/globalVmExtensionPolicies/insert#body.Operation.SCHEMA_REPRESENTATION.error.SCHEMA_REPRESENTATION.error_details.SCHEMA_REPRESENTATION_2)
      - [JSON representation](https://docs.cloud.google.com/compute/docs/reference/rest/beta/globalVmExtensionPolicies/insert#body.Operation.SCHEMA_REPRESENTATION.error.SCHEMA_REPRESENTATION.error_details.SCHEMA_REPRESENTATION_3)
    - [JSON representation](https://docs.cloud.google.com/compute/docs/reference/rest/beta/globalVmExtensionPolicies/insert#body.Operation.SCHEMA_REPRESENTATION.warning.SCHEMA_REPRESENTATION)
    - [JSON representation](https://docs.cloud.google.com/compute/docs/reference/rest/beta/globalVmExtensionPolicies/insert#body.Operation.SCHEMA_REPRESENTATION.set_common_instance_metadata_operation_metadata.inlinedField_1.map_entry1.value.SCHEMA_REPRESENTATION)
    - [JSON representation](https://docs.cloud.google.com/compute/docs/reference/rest/beta/globalVmExtensionPolicies/insert#body.Operation.SCHEMA_REPRESENTATION.get_version_operation_metadata.SCHEMA_REPRESENTATION)
    - [JSON representation](https://docs.cloud.google.com/compute/docs/reference/rest/beta/globalVmExtensionPolicies/insert#body.Operation.SCHEMA_REPRESENTATION.get_health_operation_metadata.SCHEMA_REPRESENTATION)
- [Authorization scopes](https://docs.cloud.google.com/compute/docs/reference/rest/beta/globalVmExtensionPolicies/insert#body.aspect)
- [IAM Permissions](https://docs.cloud.google.com/compute/docs/reference/rest/beta/globalVmExtensionPolicies/insert#body.aspect_1)
- [Try it!](https://docs.cloud.google.com/compute/docs/reference/rest/beta/globalVmExtensionPolicies/insert#try-it)

Creates a new project level GlobalVmExtensionPolicy.

### HTTP request

Choose an endpoint:
global africa-south1 asia-east1 asia-east2 asia-northeast1 asia-northeast2 asia-northeast3 asia-south1 asia-south2 asia-southeast1 asia-southeast2 asia-southeast3 australia-southeast1 australia-southeast2 europe-central2 europe-north1 europe-north2 europe-southwest1 europe-west1 europe-west10 europe-west12 europe-west2 europe-west3 europe-west4 europe-west6 europe-west8 europe-west9 me-central1 me-central2 me-west1 northamerica-northeast1 northamerica-northeast2 northamerica-south1 southamerica-east1 southamerica-west1 us-central1 us-east1 us-east4 us-east5 us-south1 us-west1 us-west2 us-west3 us-west4   
`POST https://compute.googleapis.com/compute/beta/projects/{project}/global/vmExtensionPolicies`

<br />

The URLs use [gRPC Transcoding](https://google.aip.dev/127) syntax.

### Path parameters

| Parameters ||
|---|---|
| `project` | `string` Project ID for this request. |

### Query parameters

| Parameters ||
|---|---|
| `requestId` | `string` An optional request ID to identify requests. Specify a unique request ID so that if you must retry your request, the server will know to ignore the request if it has already been completed. For example, consider a situation where you make an initial request and the request times out. If you make the request again with the same request ID, the server can check if original operation with the same request ID was received, and if so, will ignore the second request. This prevents clients from accidentally creating duplicate commitments. The request ID must be a valid [UUID](https://tools.ietf.org/html/rfc4122) with the exception that zero UUID is not supported (`00000000-0000-0000-0000-000000000000`). |

### Request body

The request body contains data with the following structure:

| JSON representation |
|---|
| ``` { "kind": string, "id": string, "creationTimestamp": string, "updateTimestamp": string, "name": string, "description": string, "selfLink": string, "selfLinkWithId": string, "extensionPolicies": { string: { "stringConfig": string, "pinnedVersion": string }, ... }, "instanceSelectors": [ { "labelSelector": { "inclusionLabels": { string: string, ... } } } ], "priority": integer, "scopedResourceStatus": enum, "rolloutOperation": { "rolloutInput": { "retryUuid": string, "conflictBehavior": string, // The following is a list of mutually exclusive fields. At most one of the // fields will be set in a response: "name": string, "predefinedRolloutPlan": enum // End of mutually exclusive fields. }, "rolloutStatus": { "currentRollouts": [ { "rollout": string, "rolloutPlan": string, "state": enum, "locationRolloutStatus": { string: { "state": enum }, ... } } ], "previousRollout": { "rollout": string, "rolloutPlan": string, "state": enum, "locationRolloutStatus": { string: { "state": enum }, ... } } } } } ``` |

| Fields ||
|---|---|
| `kind` | `string` Output only. Type of the resource. Always `compute#globalVmExtensionPolicy` for globalVmExtensionPolicies. |
| `id` | `string (https://developers.google.com/discovery/v1/type-format format)` Output only. The unique identifier for the resource. This identifier is defined by the server. |
| `creationTimestamp` | `string` Output only. Creation timestamp in [RFC3339](https://www.ietf.org/rfc/rfc3339.txt) text format. |
| `updateTimestamp` | `string` Output only. globalVmExtensionPolicies.update timestamp in [RFC3339](https://www.ietf.org/rfc/rfc3339.txt) text format. |
| `name` | `string` Name of the resource. Provided by the client when the resource is created. The name must be 1-63 characters long, and comply with [RFC1035](https://www.ietf.org/rfc/rfc1035.txt). Specifically, the name must be 1-63 characters long and match the regular expression `[a-z]([-a-z0-9]*[a-z0-9])?` which means the first character must be a lowercase letter, and all following characters must be a dash, lowercase letter, or digit, except the last character, which cannot be a dash. |
| `description` | `string` An optional description of this resource. Provide this property when you create the resource. |
| `selfLink` | `string` Output only. Server-defined fully-qualified URL for this resource. |
| `selfLinkWithId` | `string` Output only. Server-defined URL for this resource's resource id. |
| `extensionPolicies[]` | `map (key: string, value: object)` Required. Map from extension (eg: "cloudops") to its policy configuration. The key is the name of the extension. |
| `extensionPolicies[].stringConfig` | `string` Optional. String configuration. Any string payload that the extension understands. |
| `extensionPolicies[].pinnedVersion` | `string` Optional. The version pinning for the extension. If empty, the extension will be installed with the latest version released by the extension producer. |
| `instanceSelectors[]` | `object` Optional. Selector to target VMs for a policy. There is a logical "AND" between instanceSelectors. |
| `instanceSelectors[].labelSelector` | `object` Optional. Labels within the LabelSelector are OR'd. |
| `instanceSelectors[].labelSelector.inclusionLabels` | `map (key: string, value: string)` Optional. Labels as key value pairs. A VM should contain all the pairs specified in this map to be selected; Labels within the LabelSelector are OR'ed. |
| `priority` | `integer` Optional. Used to resolve conflicts when multiple policies are active for the same extension. Defaults to 0. Larger the number, higher the priority. When the priority is the same, the policy with the newer create time has higher priority. |
| `scopedResourceStatus` | `enum` Output only. The scoped resource status. It's only for tracking the purging status of the policy. |
| `rolloutOperation` | `object` Required. The rollout strategy and status. |
| `rolloutOperation.rolloutInput` | `object` Required. The rollout input which defines the rollout plan. |
| `rolloutOperation.rolloutInput.name` | `string` Optional. The name of the rollout plan. Ex. projects//locations/global/rolloutPlans/. |
| `rolloutOperation.rolloutInput.predefinedRolloutPlan` | `enum` Optional. Specifies the predefined rollout plan for the policy. Valid values are `SLOW_ROLLOUT` and `FAST_ROLLOUT`. The recommended value is `SLOW_ROLLOUT` for progressive rollout. For more information, see [Rollout plans for global policies](https://docs.cloud.google.com/compute/docs/vm-extensions/about-global-policies#rollout-global-policies). |
| `rolloutOperation.rolloutInput.retryUuid` | `string` Optional. The UUID that identifies a policy rollout retry attempt for update and delete operations. Set this field only when retrying a rollout for an existing extension policy. - `update` method: Lets you retry policy rollout without changes. An error occurs if you set retryUuid but the policy is modified. - `delete` method: Lets you retry policy deletion rollout if the previous deletion rollout is not finished and the policy is in the DELETING state. If you set this field when the policy is not in the DELETING state, an error occurs. |
| `rolloutOperation.rolloutInput.conflictBehavior` | `string` Optional. Specifies the behavior of the rollout if a conflict is detected in a project during a rollout. This only applies to `insert` and `update` methods. A conflict occurs in the following cases: - `insert` method: If the zonal policy already exists when the insert happens. - `update` method: If the zonal policy was modified by a zonal API call outside of this rollout. Possible values are the following: - `""` (empty string): If a conflict occurs, the local value is not overwritten. This is the default behavior. - `"overwrite"`: If a conflict occurs, the local value is overwritten with the rollout value. |
| `rolloutOperation.rolloutStatus` | `object` Output only. The rollout status of the policy. |
| `rolloutOperation.rolloutStatus.currentRollouts[]` | `object` Output only. The current rollouts for the latest version of the resource. There should be only one current rollout, but for scalability, we make it repeated. |
| `rolloutOperation.rolloutStatus.currentRollouts[].rollout` | `string` Output only. The name of the rollout. Ex. projects//locations/global/rollouts/. |
| `rolloutOperation.rolloutStatus.currentRollouts[].rolloutPlan` | `string` Output only. The name of the rollout plan. Ex. projects//locations/global/rolloutPlans/. |
| `rolloutOperation.rolloutStatus.currentRollouts[].state` | `enum` Output only. The overall state of the rollout. |
| `rolloutOperation.rolloutStatus.currentRollouts[].locationRolloutStatus[]` | `map (key: string, value: object)` Output only. The rollout status for each location. The list of the locations is the same as the list of locations in the rollout plan. |
| `rolloutOperation.rolloutStatus.currentRollouts[].locationRolloutStatus[].state` | `enum` Output only. The state of the location rollout. |
| `rolloutOperation.rolloutStatus.previousRollout` | `object` Output only. The last completed rollout resource. This field will not be populated until the first rollout is completed. |
| `rolloutOperation.rolloutStatus.previousRollout.rollout` | `string` Output only. The name of the rollout. Ex. projects//locations/global/rollouts/. |
| `rolloutOperation.rolloutStatus.previousRollout.rolloutPlan` | `string` Output only. The name of the rollout plan. Ex. projects//locations/global/rolloutPlans/. |
| `rolloutOperation.rolloutStatus.previousRollout.state` | `enum` Output only. The overall state of the rollout. |
| `rolloutOperation.rolloutStatus.previousRollout.locationRolloutStatus[]` | `map (key: string, value: object)` Output only. The rollout status for each location. The list of the locations is the same as the list of locations in the rollout plan. |
| `rolloutOperation.rolloutStatus.previousRollout.locationRolloutStatus[].state` | `enum` Output only. The state of the location rollout. |

### Response body

Represents an Operation resource.

Google Compute Engine has three Operation resources:

- [Global](https://docs.cloud.google.com/compute/docs/reference/rest/beta/globalOperations)
- [Regional](https://docs.cloud.google.com/compute/docs/reference/rest/beta/regionOperations)
- [Zonal](https://docs.cloud.google.com/compute/docs/reference/rest/beta/zoneOperations)

You can use an operation resource to manage asynchronous API requests. For more information, read [Handling API responses](https://docs.cloud.google.com/compute/docs/api/how-tos/api-requests-responses#handling_api_responses).

Operations can be global, regional or zonal.

- For global operations, use the `globalOperations` resource.
- For regional operations, use the `regionOperations` resource.
- For zonal operations, use the `zoneOperations` resource.

<br />

For more information, read [Global, Regional, and Zonal Resources](https://docs.cloud.google.com/compute/docs/regions-zones/global-regional-zonal-resources).

Note that completed Operation resources have a limited [retention period.](https://cloud.google.com/compute/docs/instances/viewing-compute-operations#operation-retention-period)

If successful, the response body contains data with the following structure:

| JSON representation |
|---|
| ``` { "kind": string, "id": string, "creationTimestamp": string, "name": string, "zone": string, "clientOperationId": string, "operationType": string, "targetLink": string, "targetId": string, "status": enum, "statusMessage": string, "user": string, "progress": integer, "insertTime": string, "startTime": string, "endTime": string, "error": { "errors": [ { "code": string, "location": string, "message": string, "errorDetails": [ { "errorInfo": { "reason": string, "domain": string, "metadatas": { string: string, ... } }, "quotaInfo": { "metricName": string, "limitName": string, "dimensions": { string: string, ... }, "limit": number, "futureLimit": number, "rolloutStatus": enum }, "help": { "links": [ { "description": string, "url": string } ] }, "localizedMessage": { "locale": string, "message": string } } ] } ] }, "warnings": [ { "code": enum, "message": string, "data": [ { "key": string, "value": string } ] } ], "httpErrorStatusCode": integer, "httpErrorMessage": string, "selfLink": string, "region": string, "description": string, "operationGroupId": string, // The following is a list of mutually exclusive fields. At most one of the // fields will be set in a response: "setCommonInstanceMetadataOperationMetadata": { "clientOperationId": string, "perLocationOperations": { string: { "state": enum, "error": { "code": integer, "message": string, "details": [ { "@type": string, field1: ..., ... } ] } }, ... } }, "instancesBulkInsertOperationMetadata": { "perLocationStatus": { string: { "status": enum, "targetVmCount": integer, "createdVmCount": integer, "failedToCreateVmCount": integer, "deletedVmCount": integer }, ... } }, "getVersionOperationMetadata": { "inlineSbomInfo": { "currentComponentVersions": { string: string, ... }, "targetComponentVersions": { string: string, ... } } }, "getHealthOperationMetadata": { "healthInfo": { "healthStatus": enum, "unhealthyReason": enum, "repairCategory": enum, "availabilitySloStatus": enum, "updateTime": string } } // End of mutually exclusive fields. } ``` |

| Fields ||
|---|---|
| `kind` | `string` Output only. Type of the resource. Always `compute#operation` for Operation resources. |
| `id` | `string (https://developers.google.com/discovery/v1/type-format format)` Output only. The unique identifier for the operation. This identifier is defined by the server. |
| `creationTimestamp` | `string` \[Deprecated\] This field is deprecated. |
| `name` | `string` Output only. Name of the operation. |
| `zone` | `string` Output only. The URL of the zone where the operation resides. Only applicable when performing per-zone operations. |
| `clientOperationId` | `string` Output only. The value of `requestId` if you provided it in the request. Not present otherwise. |
| `operationType` | `string` Output only. The type of operation, such as `insert`, `update`, or `delete`, and so on. |
| `targetLink` | `string` Output only. The URL of the resource that the operation modifies. For operations related to creating a snapshot, this points to the disk that the snapshot was created from. |
| `targetId` | `string (https://developers.google.com/discovery/v1/type-format format)` Output only. The unique target ID, which identifies a specific incarnation of the target resource. |
| `status` | `enum` Output only. The status of the operation, which can be one of the following: `PENDING`, `RUNNING`, or `DONE`. |
| `statusMessage` | `string` Output only. An optional textual description of the current status of the operation. |
| `user` | `string` Output only. User who requested the operation, for example: `user@example.com` or `alice_smith_identifier (global/workforcePools/example-com-us-employees)`. |
| `progress` | `integer` Output only. An optional progress indicator that ranges from 0 to 100. There is no requirement that this be linear or support any granularity of operations. This should not be used to guess when the operation will be complete. This number should monotonically increase as the operation progresses. |
| `insertTime` | `string` Output only. The time that this operation was requested. This value is in [RFC3339](https://www.ietf.org/rfc/rfc3339.txt) text format. |
| `startTime` | `string` Output only. The time that this operation was started by the server. This value is in [RFC3339](https://www.ietf.org/rfc/rfc3339.txt) text format. |
| `endTime` | `string` Output only. The time that this operation was completed. This value is in [RFC3339](https://www.ietf.org/rfc/rfc3339.txt) text format. |
| `error` | `object` Output only. If errors are generated during processing of the operation, this field will be populated. |
| `error.errors[]` | `object` Output only. The array of errors encountered while processing this operation. |
| `error.errors[].code` | `string` Output only. The error type identifier for this error. |
| `error.errors[].location` | `string` Output only. Indicates the field in the request that caused the error. This property is optional. |
| `error.errors[].message` | `string` Output only. An optional, human-readable error message. |
| `error.errors[].errorDetails[]` | `object` Output only. An optional list of messages that contain the error details. There is a set of defined message types to use for providing details.The syntax depends on the error code. For example, QuotaExceededInfo will have details when the error code is QUOTA_EXCEEDED. |
| `error.errors[].errorDetails[].errorInfo` | `object` Error information containing structured domain, reason, and metadata. |
| `error.errors[].errorDetails[].errorInfo.reason` | `string` The reason of the error. This is a constant value that identifies the proximate cause of the error. Error reasons are unique within a particular domain of errors. This should be at most 63 characters and match a regular expression of `[A-Z][A-Z0-9_]+[A-Z0-9]`, which represents UPPER_SNAKE_CASE. |
| `error.errors[].errorDetails[].errorInfo.domain` | `string` The logical grouping to which the "reason" belongs. The error domain is typically the registered service name of the tool or product that generates the error. Example: "pubsub.googleapis.com". If the error is generated by some common infrastructure, the error domain must be a globally unique value that identifies the infrastructure. For Google API infrastructure, the error domain is "googleapis.com". |
| `error.errors[].errorDetails[].errorInfo.metadatas` | `map (key: string, value: string)` Additional structured details about this error. Keys must match a regular expression of `[a-z][a-zA-Z0-9-_]+` but should ideally be lowerCamelCase. Also, they must be limited to 64 characters in length. When identifying the current value of an exceeded limit, the units should be contained in the key, not the value. For example, rather than `{"instanceLimit": "100/request"}`, should be returned as, `{"instanceLimitPerRequest": "100"}`, if the client exceeds the number of instances that can be created in a single (batch) request. |
| `error.errors[].errorDetails[].quotaInfo` | `object` Details about quota limits and metrics when a quota is exceeded. |
| `error.errors[].errorDetails[].quotaInfo.metricName` | `string` The Compute Engine quota metric name. |
| `error.errors[].errorDetails[].quotaInfo.limitName` | `string` The name of the quota limit. |
| `error.errors[].errorDetails[].quotaInfo.dimensions` | `map (key: string, value: string)` The map holding related quota dimensions. |
| `error.errors[].errorDetails[].quotaInfo.limit` | `number` Current effective quota limit. The limit's unit depends on the quota type or metric. |
| `error.errors[].errorDetails[].quotaInfo.futureLimit` | `number` Future quota limit being rolled out. The limit's unit depends on the quota type or metric. |
| `error.errors[].errorDetails[].quotaInfo.rolloutStatus` | `enum` Rollout status of the future quota limit. |
| `error.errors[].errorDetails[].help` | `object` Links and information to help the user resolve the error. |
| `error.errors[].errorDetails[].help.links[]` | `object` URL(s) pointing to additional information on handling the current error. |
| `error.errors[].errorDetails[].help.links[].description` | `string` Describes what the link offers. |
| `error.errors[].errorDetails[].help.links[].url` | `string` The URL of the link. |
| `error.errors[].errorDetails[].localizedMessage` | `object` A localized human-readable error message intended for end users. |
| `error.errors[].errorDetails[].localizedMessage.locale` | `string` The locale used following the specification defined at <https://www.rfc-editor.org/rfc/bcp/bcp47.txt>. Examples are: "en-US", "fr-CH", "es-MX" |
| `error.errors[].errorDetails[].localizedMessage.message` | `string` The localized error message in the above locale. |
| `warnings[]` | `object` Output only. If warning messages are generated during processing of the operation, this field will be populated. |
| `warnings[].code` | `enum` Output only. A warning code, if applicable. For example, Compute Engine returns `NO_RESULTS_ON_PAGE` if there are no results in the response. |
| `warnings[].message` | `string` Output only. A human-readable description of the warning code. |
| `warnings[].data[]` | `object` Output only. Metadata about this warning in `key: value` format. For example: ```html "data": [  {  "key": "scope",  "value": "zones/us-east1-d"  }] ``` <br /> |
| `warnings[].data[].key` | `string` Output only. A key that provides more detail on the warning being returned. For example, for warnings where there are no results in a list request for a particular zone, this key might be `scope` and the key value might be the zone name. Other examples might be a key indicating a deprecated resource and a suggested replacement, or a warning about invalid network settings (for example, if an instance attempts to perform IP forwarding but is not enabled for IP forwarding). |
| `warnings[].data[].value` | `string` Output only. A warning data value corresponding to the key. |
| `httpErrorStatusCode` | `integer` Output only. If the operation fails, this field contains the HTTP error status code that was returned. For example, a `404` means the resource was not found. |
| `httpErrorMessage` | `string` Output only. If the operation fails, this field contains the HTTP error message that was returned, such as `NOT FOUND`. |
| `selfLink` | `string` Output only. Server-defined URL for the resource. |
| `region` | `string` Output only. The URL of the region where the operation resides. Only applicable when performing regional operations. |
| `description` | `string` Output only. A textual description of the operation, which is set when the operation is created. |
| `operationGroupId` | `string` Output only. An ID that represents a group of operations, such as when a group of operations results from a `bulkInsert` API request. |
| Output only. Service-specific metadata attached to this operation. The following is a list of mutually exclusive fields. At most one of the fields will be set in a response: ||
| `setCommonInstanceMetadataOperationMetadata` | `object` Output only. If the operation is for projects.setCommonInstanceMetadata, this field will contain information on all underlying zonal actions and their state. |
| `setCommonInstanceMetadataOperationMetadata.clientOperationId` | `string` Output only. The client operation id. |
| `setCommonInstanceMetadataOperationMetadata.perLocationOperations[]` | `map (key: string, value: object)` Output only. Status information per location (location name is key). Example key: zones/us-central1-a |
| `setCommonInstanceMetadataOperationMetadata.perLocationOperations[].state` | `enum` Output only. Status of the action, which can be one of the following: `PROPAGATING`, `PROPAGATED`, `ABANDONED`, `FAILED`, or `DONE`. |
| `setCommonInstanceMetadataOperationMetadata.perLocationOperations[].error` | `object` Output only. If state is `ABANDONED` or `FAILED`, this field is populated. |
| `setCommonInstanceMetadataOperationMetadata.perLocationOperations[].error.code` | `integer` The status code, which should be an enum value of `google.rpc.Code`. |
| `setCommonInstanceMetadataOperationMetadata.perLocationOperations[].error.message` | `string` A developer-facing error message, which should be in English. Any user-facing error message should be localized and sent in the `google.rpc.Status.details` field, or localized by the client. |
| `setCommonInstanceMetadataOperationMetadata.perLocationOperations[].error.details[]` | `object` A list of messages that carry the error details. There is a common set of message types for APIs to use. An object containing fields of an arbitrary type. An additional field `"@type"` contains a URI identifying the type. Example: `{ "id": 1234, "@type": "types.example.com/standard/id" }`. |
| `instancesBulkInsertOperationMetadata` | `object` |
| `instancesBulkInsertOperationMetadata.perLocationStatus[]` | `map (key: string, value: object)` Status information per location (location name is key). Example key: zones/us-central1-a |
| `instancesBulkInsertOperationMetadata.perLocationStatus[].status` | `enum` Output only. Creation status of BulkInsert operation - information if the flow is rolling forward or rolling back. |
| `instancesBulkInsertOperationMetadata.perLocationStatus[].targetVmCount` | `integer` Output only. Count of VMs originally planned to be created. |
| `instancesBulkInsertOperationMetadata.perLocationStatus[].createdVmCount` | `integer` Output only. Count of VMs successfully created so far. |
| `instancesBulkInsertOperationMetadata.perLocationStatus[].failedToCreateVmCount` | `integer` Output only. Count of VMs that started creating but encountered an error. |
| `instancesBulkInsertOperationMetadata.perLocationStatus[].deletedVmCount` | `integer` Output only. Count of VMs that got deleted during rollback. |
| `getVersionOperationMetadata` | `object` |
| `getVersionOperationMetadata.inlineSbomInfo` | `object` |
| `getVersionOperationMetadata.inlineSbomInfo.currentComponentVersions` | `map (key: string, value: string)` A mapping of components to their currently-applied versions or other appropriate identifiers. |
| `getVersionOperationMetadata.inlineSbomInfo.targetComponentVersions` | `map (key: string, value: string)` A mapping of components to their target versions or other appropriate identifiers. |
| `getHealthOperationMetadata` | `object` Output only. Metadata for GetHealth operations. |
| `getHealthOperationMetadata.healthInfo` | `object` Output only. The health information. |
| `getHealthOperationMetadata.healthInfo.healthStatus` | `enum` Output only. The health status. |
| `getHealthOperationMetadata.healthInfo.unhealthyReason` | `enum` Output only. The reason for unhealthy status. |
| `getHealthOperationMetadata.healthInfo.repairCategory` | `enum` Output only. The repair category. |
| `getHealthOperationMetadata.healthInfo.availabilitySloStatus` | `enum` Output only. The availability SLO status. |
| `getHealthOperationMetadata.healthInfo.updateTime` | ``string (`https://protobuf.dev/reference/protobuf/google.protobuf#timestamp` format)`` Output only. The time when health info was updated. Uses RFC 3339, where generated output will always be Z-normalized and use 0, 3, 6 or 9 fractional digits. Offsets other than "Z" are also accepted. Examples: `"2014-10-02T15:01:23Z"`, `"2014-10-02T15:01:23.045123456Z"` or `"2014-10-02T15:01:23+05:30"`. |
| End of mutually exclusive fields. ||

### Authorization scopes

Requires one of the following OAuth scopes:

- `https://www.googleapis.com/auth/compute`
- `
  https://www.googleapis.com/auth/cloud-platform`

For more information, see the [Authentication Overview](https://docs.cloud.google.com/docs/authentication#authorization-gcp).

### IAM Permissions

In addition to any permissions specified on the fields above, authorization requires one or more of the following [IAM](https://cloud.google.com/iam/docs/) permissions:

- `compute.vmExtensionPolicies.create`

To find predefined roles that contain those permissions, see [Compute Engine IAM Roles](https://docs.cloud.google.com/compute/docs/access/iam).